//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D2EE1E60227.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D2EE1E60227.cm

//## begin module%3D2EE1E60227.cp preserve=no
//## end module%3D2EE1E60227.cp

//## Module: OGIPTable%3D2EE1E60227; Package specification
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/OGIPTable/OGIPTable.h

#ifndef OGIPTABLE_H
#define OGIPTABLE_H 1

//## begin module%3D2EE1E60227.additionalIncludes preserve=no
//## end module%3D2EE1E60227.additionalIncludes

//## begin module%3D2EE1E60227.includes preserve=yes
//## end module%3D2EE1E60227.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// TableComponent
#include <XSModel/Model/Component/TableComponent.h>

class UniqueEnergy;
class TableAccess;
struct TableValues;
class ModParam;
class TableModParam;

//## begin module%3D2EE1E60227.declarations preserve=no
//## end module%3D2EE1E60227.declarations

//## begin module%3D2EE1E60227.additionalDeclarations preserve=yes
//## end module%3D2EE1E60227.additionalDeclarations


//## begin OGIPTable%3D2EE1880042.preface preserve=yes
//## end OGIPTable%3D2EE1880042.preface

//## Class: OGIPTable%3D2EE1880042; protected
//## Category: XSModel::Model::Component::OGIPTable%3D2EE54A03A6
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%43E3A1D9030D;UniqueEnergy { -> F}
//## Uses: <unnamed>%470295E1036E;TableValues { -> F}

class OGIPTable : public TableComponent  //## Inherits: <unnamed>%3D2EE1AB030B
{
  //## begin OGIPTable%3D2EE1880042.initialDeclarations preserve=yes
  //## end OGIPTable%3D2EE1880042.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: OGIPTable%3D2EEA3D01B3
      OGIPTable (const string& nameString, Component* p = 0);

    //## Destructor (generated)
      virtual ~OGIPTable();


    //## Other Operations (specified)
      //## Operation: read%3D2EE878036C; C++
      //	If p is a valid Component pointer, isAddRequest argument
      //	is irrelevant.  It only needs to be filled to verify Add
      //	or Mult type when TableComponent is used in isolation,
      //	and there is no owning Component.
      virtual void read (bool readSpectralData, Component* p, bool isAddRequest = true);

      //## Operation: clone%3D528BC400A5
      virtual OGIPTable* clone (Component* parent) const;

      //## Operation: formatCheck%3D62868600AF
      virtual bool formatCheck (const string& fileName);

      //## Operation: energyWeights%3D7CC5F70396
      virtual void energyWeights (const UniqueEnergy* uniqueEng);

      //## Operation: clearArrays%3D7CF3CD00F4
      virtual void clearArrays (const std::set<UniqueEnergy*>& currentEngs);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: MEM_THRESHOLD%46F8071F0213
      //	Interpolation tables with fewer elements than this will
      //	be read in their entirety and saved in RAM.  For larger
      //	tables only the necessary rows will be read, on the fly.
      static long MEM_THRESHOLD ();

    // Additional Public Declarations
      //## begin OGIPTable%3D2EE1880042.public preserve=yes
      //## end OGIPTable%3D2EE1880042.public

  protected:

    //## Other Operations (specified)
      //## Operation: getInterpolantIndices%3D6A3BC201B7
      virtual void getInterpolantIndices ();

      //## Operation: energyPoint%3D6B8F3D0121
      virtual std::pair<Real,Real> energyPoint (size_t energyIndex, const RealArray& fraction, TableValues& workspace);

      //## Operation: getInterpolant%3D6B8F8F00E5
      virtual void getInterpolant (RealArray& spectrum, RealArray& variance);

      //## Operation: rebinComponent%3D7D02BB0215
      //	rebin model component fluxes using weighting array.
      virtual void rebinComponent (const UniqueEnergy* uniqueEng, const RealArray& inputArray, RealArray& outputArray, bool variance);

      //## Operation: interpolateComponent%3D7D02C003C6
      //	rebin model component fluxes using weighting array.
      virtual void interpolateComponent (const UniqueEnergy* uniqueEng, const RealArray& inputArray, RealArray& outputArray, bool exponential);

      //## Operation: setParamPointersFromCopy%460A89E50083
      virtual void setParamPointersFromCopy ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: MODLNAME%3D62901D0197
      static const string& MODLNAME ();

      //## Attribute: MODLUNIT%3D62906E0277
      static const string& MODLUNIT ();

      //## Attribute: REDSHIFT%3D6290890016
      static const string& REDSHIFT ();

      //## Attribute: ADDMODEL%3D62909A018A
      static const string& ADDMODEL ();

      //## Attribute: HDUCLASS%3D6290A70111
      static const string& HDUCLASS ();

      //## Attribute: HDUCLAS1%3D6290BB009A
      static const string& HDUCLAS1 ();

      //## Attribute: HDUVERS%3D6290C403B2
      static const string& HDUVERS ();

      //## Attribute: NINTPARM%3D6290D6006F
      static const string& NINTPARM ();

      //## Attribute: NADDPARM%3D62910001E5
      static const string& NADDPARM ();

      //## Attribute: NAME%3D6291150164
      static const string& NAME ();

      //## Attribute: METHOD%3D6291240162
      static const string& METHOD ();

      //## Attribute: INITIAL%3D6291260215
      static const string& INITIAL ();

      //## Attribute: DELTA%3D62912801B4
      static const string& DELTA ();

      //## Attribute: MINIMUM%3D62912B00C9
      static const string& MINIMUM ();

      //## Attribute: BOTTOM%3D62912C031C
      static const string& BOTTOM ();

      //## Attribute: TOP%3D62912E00F3
      static const string& TOP ();

      //## Attribute: MAXIMUM%3D62917E032F
      static const string& MAXIMUM ();

      //## Attribute: NUMBVALS%3D62918000A5
      static const string& NUMBVALS ();

      //## Attribute: VALUE%3D62918102A6
      static const string& VALUE ();

      //## Attribute: HDUCLAS2%3D62927903E4
      static const string& HDUCLAS2 ();

      //## Attribute: ENERG_LO%3D62927B02A0
      static const string& ENERG_LO ();

      //## Attribute: ENERG_HI%3D62927E038E
      static const string& ENERG_HI ();

      //## Attribute: PARAMVAL%3D6292800053
      static const string& PARAMVAL ();

      //## Attribute: INTPSPEC%3D62928100DD
      static const string& INTPSPEC ();

      //## Attribute: UNITS%3D653E7B0301
      static const string& UNITS ();

      //## Attribute: HDUVERS1%3D6A3DC50320
      static const string& HDUVERS1 ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::Interpolation Parameters%3D6B9512012C
      //## Role: OGIPTable::interParam%3D6B95120309
      const std::vector<TableModParam*>& interParam () const;
      void interParam (const std::vector<TableModParam*>& value);

      //## Association: XSModel::Model::Component::<unnamed>%3D6CF0550094
      //## Role: OGIPTable::exact%3D6CF05502C9
      const BoolArray& exact () const;
      void setExact (const BoolArray& value);

      //## Association: XSModel::Model::Component::<unnamed>%3E42CB910232
      //## Role: OGIPTable::recordNumbers%3E42CB9201FB
      const IntegerArray& recordNumbers () const;
      void setRecordNumbers (const IntegerArray& value);

      //## Association: XSModel::Model::Component::<unnamed>%3E42CBD60266
      //## Role: OGIPTable::bracket%3E42CBD701AB
      const IntegerArray& bracket () const;
      void setBracket (const IntegerArray& value);

      //## Association: XSModel::Model::Component::Additional Parameters%44E33E660011
      //## Role: OGIPTable::addParam%44E33E680193
      const std::vector<ModParam*>& addParam () const;
      void addParam (const std::vector<ModParam*>& value);

    // Additional Protected Declarations
      //## begin OGIPTable%3D2EE1880042.protected preserve=yes
      //## end OGIPTable%3D2EE1880042.protected

  private:
    //## Constructors (generated)
      OGIPTable(const OGIPTable &right);

    //## Assignment Operation (generated)
      OGIPTable & operator=(const OGIPTable &right);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Model::Component::Start Weight%3D7CF9270385
      //## Role: OGIPTable::startWeight%3D7CF9280320
      //## Qualifier: uniqueEng%3D7CF959015E; const UniqueEnergy*
      RealArray& startWeight (const UniqueEnergy* uniqueEng);

      //## Association: XSModel::Model::Component::End Weight%3D7CF9CF01E6
      //## Role: OGIPTable::endWeight%3D7CF9D001BF
      //## Qualifier: uniqueEng%3D7CF9F501C0; const UniqueEnergy*
      RealArray& endWeight (const UniqueEnergy* uniqueEng);

    // Additional Private Declarations
      //## begin OGIPTable%3D2EE1880042.private preserve=yes
      //## end OGIPTable%3D2EE1880042.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin OGIPTable::MODLNAME%3D62901D0197.attr preserve=no  protected: static string {UC} "MODLNAME"
      static const string s_MODLNAME;
      //## end OGIPTable::MODLNAME%3D62901D0197.attr

      //## begin OGIPTable::MODLUNIT%3D62906E0277.attr preserve=no  protected: static string {UC} "MODLUNIT"
      static const string s_MODLUNIT;
      //## end OGIPTable::MODLUNIT%3D62906E0277.attr

      //## begin OGIPTable::REDSHIFT%3D6290890016.attr preserve=no  protected: static string {UC} "REDSHIFT"
      static const string s_REDSHIFT;
      //## end OGIPTable::REDSHIFT%3D6290890016.attr

      //## begin OGIPTable::ADDMODEL%3D62909A018A.attr preserve=no  protected: static string {UC} "ADDMODEL"
      static const string s_ADDMODEL;
      //## end OGIPTable::ADDMODEL%3D62909A018A.attr

      //## begin OGIPTable::HDUCLASS%3D6290A70111.attr preserve=no  protected: static string {UC} "HDUCLASS"
      static const string s_HDUCLASS;
      //## end OGIPTable::HDUCLASS%3D6290A70111.attr

      //## begin OGIPTable::HDUCLAS1%3D6290BB009A.attr preserve=no  protected: static string {UC} "HDUCLAS1"
      static const string s_HDUCLAS1;
      //## end OGIPTable::HDUCLAS1%3D6290BB009A.attr

      //## begin OGIPTable::HDUVERS%3D6290C403B2.attr preserve=no  protected: static string {UC} "HDUVERS"
      static const string s_HDUVERS;
      //## end OGIPTable::HDUVERS%3D6290C403B2.attr

      //## begin OGIPTable::NINTPARM%3D6290D6006F.attr preserve=no  protected: static string {UC} "NINTPARM"
      static const string s_NINTPARM;
      //## end OGIPTable::NINTPARM%3D6290D6006F.attr

      //## begin OGIPTable::NADDPARM%3D62910001E5.attr preserve=no  protected: static string {UC} "NADDPARM"
      static const string s_NADDPARM;
      //## end OGIPTable::NADDPARM%3D62910001E5.attr

      //## begin OGIPTable::NAME%3D6291150164.attr preserve=no  protected: static string {UC} "NAME"
      static const string s_NAME;
      //## end OGIPTable::NAME%3D6291150164.attr

      //## begin OGIPTable::METHOD%3D6291240162.attr preserve=no  protected: static string {UC} "METHOD"
      static const string s_METHOD;
      //## end OGIPTable::METHOD%3D6291240162.attr

      //## begin OGIPTable::INITIAL%3D6291260215.attr preserve=no  protected: static string {UC} "INITIAL"
      static const string s_INITIAL;
      //## end OGIPTable::INITIAL%3D6291260215.attr

      //## begin OGIPTable::DELTA%3D62912801B4.attr preserve=no  protected: static string {UC} "DELTA"
      static const string s_DELTA;
      //## end OGIPTable::DELTA%3D62912801B4.attr

      //## begin OGIPTable::MINIMUM%3D62912B00C9.attr preserve=no  protected: static string {UC} "MINIMUM"
      static const string s_MINIMUM;
      //## end OGIPTable::MINIMUM%3D62912B00C9.attr

      //## begin OGIPTable::BOTTOM%3D62912C031C.attr preserve=no  protected: static string {UC} "BOTTOM"
      static const string s_BOTTOM;
      //## end OGIPTable::BOTTOM%3D62912C031C.attr

      //## begin OGIPTable::TOP%3D62912E00F3.attr preserve=no  protected: static string {UC} "TOP"
      static const string s_TOP;
      //## end OGIPTable::TOP%3D62912E00F3.attr

      //## begin OGIPTable::MAXIMUM%3D62917E032F.attr preserve=no  protected: static string {UC} "MAXIMUM"
      static const string s_MAXIMUM;
      //## end OGIPTable::MAXIMUM%3D62917E032F.attr

      //## begin OGIPTable::NUMBVALS%3D62918000A5.attr preserve=no  protected: static string {UC} "NUMBVALS"
      static const string s_NUMBVALS;
      //## end OGIPTable::NUMBVALS%3D62918000A5.attr

      //## begin OGIPTable::VALUE%3D62918102A6.attr preserve=no  protected: static string {UC} "VALUE"
      static const string s_VALUE;
      //## end OGIPTable::VALUE%3D62918102A6.attr

      //## begin OGIPTable::HDUCLAS2%3D62927903E4.attr preserve=no  protected: static string {UC} "HDUCLAS2"
      static const string s_HDUCLAS2;
      //## end OGIPTable::HDUCLAS2%3D62927903E4.attr

      //## begin OGIPTable::ENERG_LO%3D62927B02A0.attr preserve=no  protected: static string {UC} "ENERG_LO"
      static const string s_ENERG_LO;
      //## end OGIPTable::ENERG_LO%3D62927B02A0.attr

      //## begin OGIPTable::ENERG_HI%3D62927E038E.attr preserve=no  protected: static string {UC} "ENERG_HI"
      static const string s_ENERG_HI;
      //## end OGIPTable::ENERG_HI%3D62927E038E.attr

      //## begin OGIPTable::PARAMVAL%3D6292800053.attr preserve=no  protected: static string {UC} "PARAMVAL"
      static const string s_PARAMVAL;
      //## end OGIPTable::PARAMVAL%3D6292800053.attr

      //## begin OGIPTable::INTPSPEC%3D62928100DD.attr preserve=no  protected: static string {UC} "INTPSPEC"
      static const string s_INTPSPEC;
      //## end OGIPTable::INTPSPEC%3D62928100DD.attr

      //## Attribute: init%3D639BD701C5
      //## begin OGIPTable::init%3D639BD701C5.attr preserve=no  implementation: static bool {U} false
      static bool s_init;
      //## end OGIPTable::init%3D639BD701C5.attr

      //## begin OGIPTable::UNITS%3D653E7B0301.attr preserve=no  protected: static string {UC} "UNITS"
      static const string s_UNITS;
      //## end OGIPTable::UNITS%3D653E7B0301.attr

      //## begin OGIPTable::HDUVERS1%3D6A3DC50320.attr preserve=no  protected: static string {UC} "HDUVERS1"
      static const string s_HDUVERS1;
      //## end OGIPTable::HDUVERS1%3D6A3DC50320.attr

      //## Attribute: FUZZY%3D908C9901D1
      //## begin OGIPTable::FUZZY%3D908C9901D1.attr preserve=no  private: static Real {UC} 1.E-06
      static const Real FUZZY;
      //## end OGIPTable::FUZZY%3D908C9901D1.attr

      //## begin OGIPTable::MEM_THRESHOLD%46F8071F0213.attr preserve=no  public: static long {UC} 100000
      static const long s_MEM_THRESHOLD;
      //## end OGIPTable::MEM_THRESHOLD%46F8071F0213.attr

      //## Attribute: prevFile%46FA6ADE02CB
      //	Absolute path to the most recently opened table model
      //	file.
      //## begin OGIPTable::prevFile%46FA6ADE02CB.attr preserve=no  private: static string {U} string("")
      static string s_prevFile;
      //## end OGIPTable::prevFile%46FA6ADE02CB.attr

    // Data Members for Associations

      //## Association: XSModel::Model::Component::<unnamed>%3D65116E0359
      //## Role: OGIPTable::paramStrings%3D65116F0236
      //## begin OGIPTable::paramStrings%3D65116F0236.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_paramStrings;
      //## end OGIPTable::paramStrings%3D65116F0236.role

      //## Association: XSModel::Model::Component::<unnamed>%3D65129103CA
      //## Role: OGIPTable::energyStrings%3D6512920242
      //## begin OGIPTable::energyStrings%3D6512920242.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_energyStrings;
      //## end OGIPTable::energyStrings%3D6512920242.role

      //## Association: XSModel::Model::Component::<unnamed>%3D6513B20153
      //## Role: OGIPTable::spectrumStrings%3D6513B400F5
      //## begin OGIPTable::spectrumStrings%3D6513B400F5.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_spectrumStrings;
      //## end OGIPTable::spectrumStrings%3D6513B400F5.role

      //## Association: XSModel::Model::Component::<unnamed>%3D65275C032D
      //## Role: OGIPTable::hduPrimary%3D65275D01AA
      //## begin OGIPTable::hduPrimary%3D65275D01AA.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_hduPrimary;
      //## end OGIPTable::hduPrimary%3D65275D01AA.role

      //## Association: XSModel::Model::Component::<unnamed>%3D652784027C
      //## Role: OGIPTable::hduNames%3D652785025F
      //## begin OGIPTable::hduNames%3D652785025F.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_hduNames;
      //## end OGIPTable::hduNames%3D652785025F.role

      //## Association: XSModel::Model::Component::Interpolation Parameters%3D6B9512012C
      //## begin OGIPTable::interParam%3D6B95120309.role preserve=no  protected: TableModParam { -> 1..nRFHgN}
      std::vector<TableModParam*> m_interParam;
      //## end OGIPTable::interParam%3D6B95120309.role

      //## Association: XSModel::Model::Component::<unnamed>%3D6CF0550094
      //## begin OGIPTable::exact%3D6CF05502C9.role preserve=no  protected: BoolArray { -> 1VHgN}
      BoolArray m_exact;
      //## end OGIPTable::exact%3D6CF05502C9.role

      //## Association: XSModel::Model::Component::Start Weight%3D7CF9270385
      //## begin OGIPTable::startWeight%3D7CF9280320.role preserve=no  private: RealArray { -> 1..nRHN}
      std::map<const UniqueEnergy*,RealArray> m_startWeight;
      //## end OGIPTable::startWeight%3D7CF9280320.role

      //## Association: XSModel::Model::Component::End Weight%3D7CF9CF01E6
      //## begin OGIPTable::endWeight%3D7CF9D001BF.role preserve=no  private: RealArray { -> 1..nVHgN}
      std::map<const UniqueEnergy*,RealArray> m_endWeight;
      //## end OGIPTable::endWeight%3D7CF9D001BF.role

      //## Association: XSModel::Model::Component::<unnamed>%3E42CA990178
      //## Role: OGIPTable::startWeightBin%3E42CA9A0089
      //## begin OGIPTable::startWeightBin%3E42CA9A0089.role preserve=no  private: IntegerArray { -> 1VHgN}
      std::map<const UniqueEnergy*,IntegerArray> m_startWeightBin;
      //## end OGIPTable::startWeightBin%3E42CA9A0089.role

      //## Association: XSModel::Model::Component::<unnamed>%3E42CAE10017
      //## Role: OGIPTable::endWeightBin%3E42CAE102A5
      //## begin OGIPTable::endWeightBin%3E42CAE102A5.role preserve=no  private: IntegerArray { -> 1VHgN}
      std::map<const UniqueEnergy*,IntegerArray> m_endWeightBin;
      //## end OGIPTable::endWeightBin%3E42CAE102A5.role

      //## Association: XSModel::Model::Component::<unnamed>%3E42CB910232
      //## begin OGIPTable::recordNumbers%3E42CB9201FB.role preserve=no  protected: IntegerArray { -> 1VHgN}
      IntegerArray m_recordNumbers;
      //## end OGIPTable::recordNumbers%3E42CB9201FB.role

      //## Association: XSModel::Model::Component::<unnamed>%3E42CBD60266
      //## begin OGIPTable::bracket%3E42CBD701AB.role preserve=no  protected: IntegerArray { -> 1VHgN}
      IntegerArray m_bracket;
      //## end OGIPTable::bracket%3E42CBD701AB.role

      //## Association: XSModel::Model::Component::Additional Parameters%44E33E660011
      //## begin OGIPTable::addParam%44E33E680193.role preserve=no  protected: ModParam { -> 1..nRFHgN}
      std::vector<ModParam*> m_addParam;
      //## end OGIPTable::addParam%44E33E680193.role

      //## Association: XSModel::Model::Component::<unnamed>%46F7FFDD0095
      //## Role: OGIPTable::readStrategy%46F7FFDF01E2
      //	Opaque pointer to strategy for interp table reading
      //## begin OGIPTable::readStrategy%46F7FFDF01E2.role preserve=no  private: TableAccess { -> 1RFHgN}
      TableAccess* m_readStrategy;
      //## end OGIPTable::readStrategy%46F7FFDF01E2.role

    // Additional Implementation Declarations
      //## begin OGIPTable%3D2EE1880042.implementation preserve=yes
      //## end OGIPTable%3D2EE1880042.implementation

};

//## begin OGIPTable%3D2EE1880042.postscript preserve=yes
//## end OGIPTable%3D2EE1880042.postscript

// Class OGIPTable 

//## Get and Set Operations for Class Attributes (inline)

inline const string& OGIPTable::MODLNAME ()
{
  //## begin OGIPTable::MODLNAME%3D62901D0197.get preserve=no
  return s_MODLNAME;
  //## end OGIPTable::MODLNAME%3D62901D0197.get
}

inline const string& OGIPTable::MODLUNIT ()
{
  //## begin OGIPTable::MODLUNIT%3D62906E0277.get preserve=no
  return s_MODLUNIT;
  //## end OGIPTable::MODLUNIT%3D62906E0277.get
}

inline const string& OGIPTable::REDSHIFT ()
{
  //## begin OGIPTable::REDSHIFT%3D6290890016.get preserve=no
  return s_REDSHIFT;
  //## end OGIPTable::REDSHIFT%3D6290890016.get
}

inline const string& OGIPTable::ADDMODEL ()
{
  //## begin OGIPTable::ADDMODEL%3D62909A018A.get preserve=no
  return s_ADDMODEL;
  //## end OGIPTable::ADDMODEL%3D62909A018A.get
}

inline const string& OGIPTable::HDUCLASS ()
{
  //## begin OGIPTable::HDUCLASS%3D6290A70111.get preserve=no
  return s_HDUCLASS;
  //## end OGIPTable::HDUCLASS%3D6290A70111.get
}

inline const string& OGIPTable::HDUCLAS1 ()
{
  //## begin OGIPTable::HDUCLAS1%3D6290BB009A.get preserve=no
  return s_HDUCLAS1;
  //## end OGIPTable::HDUCLAS1%3D6290BB009A.get
}

inline const string& OGIPTable::HDUVERS ()
{
  //## begin OGIPTable::HDUVERS%3D6290C403B2.get preserve=no
  return s_HDUVERS;
  //## end OGIPTable::HDUVERS%3D6290C403B2.get
}

inline const string& OGIPTable::NINTPARM ()
{
  //## begin OGIPTable::NINTPARM%3D6290D6006F.get preserve=no
  return s_NINTPARM;
  //## end OGIPTable::NINTPARM%3D6290D6006F.get
}

inline const string& OGIPTable::NADDPARM ()
{
  //## begin OGIPTable::NADDPARM%3D62910001E5.get preserve=no
  return s_NADDPARM;
  //## end OGIPTable::NADDPARM%3D62910001E5.get
}

inline const string& OGIPTable::NAME ()
{
  //## begin OGIPTable::NAME%3D6291150164.get preserve=no
  return s_NAME;
  //## end OGIPTable::NAME%3D6291150164.get
}

inline const string& OGIPTable::METHOD ()
{
  //## begin OGIPTable::METHOD%3D6291240162.get preserve=no
  return s_METHOD;
  //## end OGIPTable::METHOD%3D6291240162.get
}

inline const string& OGIPTable::INITIAL ()
{
  //## begin OGIPTable::INITIAL%3D6291260215.get preserve=no
  return s_INITIAL;
  //## end OGIPTable::INITIAL%3D6291260215.get
}

inline const string& OGIPTable::DELTA ()
{
  //## begin OGIPTable::DELTA%3D62912801B4.get preserve=no
  return s_DELTA;
  //## end OGIPTable::DELTA%3D62912801B4.get
}

inline const string& OGIPTable::MINIMUM ()
{
  //## begin OGIPTable::MINIMUM%3D62912B00C9.get preserve=no
  return s_MINIMUM;
  //## end OGIPTable::MINIMUM%3D62912B00C9.get
}

inline const string& OGIPTable::BOTTOM ()
{
  //## begin OGIPTable::BOTTOM%3D62912C031C.get preserve=no
  return s_BOTTOM;
  //## end OGIPTable::BOTTOM%3D62912C031C.get
}

inline const string& OGIPTable::TOP ()
{
  //## begin OGIPTable::TOP%3D62912E00F3.get preserve=no
  return s_TOP;
  //## end OGIPTable::TOP%3D62912E00F3.get
}

inline const string& OGIPTable::MAXIMUM ()
{
  //## begin OGIPTable::MAXIMUM%3D62917E032F.get preserve=no
  return s_MAXIMUM;
  //## end OGIPTable::MAXIMUM%3D62917E032F.get
}

inline const string& OGIPTable::NUMBVALS ()
{
  //## begin OGIPTable::NUMBVALS%3D62918000A5.get preserve=no
  return s_NUMBVALS;
  //## end OGIPTable::NUMBVALS%3D62918000A5.get
}

inline const string& OGIPTable::VALUE ()
{
  //## begin OGIPTable::VALUE%3D62918102A6.get preserve=no
  return s_VALUE;
  //## end OGIPTable::VALUE%3D62918102A6.get
}

inline const string& OGIPTable::HDUCLAS2 ()
{
  //## begin OGIPTable::HDUCLAS2%3D62927903E4.get preserve=no
  return s_HDUCLAS2;
  //## end OGIPTable::HDUCLAS2%3D62927903E4.get
}

inline const string& OGIPTable::ENERG_LO ()
{
  //## begin OGIPTable::ENERG_LO%3D62927B02A0.get preserve=no
  return s_ENERG_LO;
  //## end OGIPTable::ENERG_LO%3D62927B02A0.get
}

inline const string& OGIPTable::ENERG_HI ()
{
  //## begin OGIPTable::ENERG_HI%3D62927E038E.get preserve=no
  return s_ENERG_HI;
  //## end OGIPTable::ENERG_HI%3D62927E038E.get
}

inline const string& OGIPTable::PARAMVAL ()
{
  //## begin OGIPTable::PARAMVAL%3D6292800053.get preserve=no
  return s_PARAMVAL;
  //## end OGIPTable::PARAMVAL%3D6292800053.get
}

inline const string& OGIPTable::INTPSPEC ()
{
  //## begin OGIPTable::INTPSPEC%3D62928100DD.get preserve=no
  return s_INTPSPEC;
  //## end OGIPTable::INTPSPEC%3D62928100DD.get
}

inline const string& OGIPTable::UNITS ()
{
  //## begin OGIPTable::UNITS%3D653E7B0301.get preserve=no
  return s_UNITS;
  //## end OGIPTable::UNITS%3D653E7B0301.get
}

inline const string& OGIPTable::HDUVERS1 ()
{
  //## begin OGIPTable::HDUVERS1%3D6A3DC50320.get preserve=no
  return s_HDUVERS1;
  //## end OGIPTable::HDUVERS1%3D6A3DC50320.get
}

inline long OGIPTable::MEM_THRESHOLD ()
{
  //## begin OGIPTable::MEM_THRESHOLD%46F8071F0213.get preserve=no
  return s_MEM_THRESHOLD;
  //## end OGIPTable::MEM_THRESHOLD%46F8071F0213.get
}

//## Get and Set Operations for Associations (inline)

inline const std::vector<TableModParam*>& OGIPTable::interParam () const
{
  //## begin OGIPTable::interParam%3D6B95120309.get preserve=no
  return m_interParam;
  //## end OGIPTable::interParam%3D6B95120309.get
}

inline void OGIPTable::interParam (const std::vector<TableModParam*>& value)
{
  //## begin OGIPTable::interParam%3D6B95120309.set preserve=no
  m_interParam = value;
  //## end OGIPTable::interParam%3D6B95120309.set
}

inline const BoolArray& OGIPTable::exact () const
{
  //## begin OGIPTable::exact%3D6CF05502C9.get preserve=no
  return m_exact;
  //## end OGIPTable::exact%3D6CF05502C9.get
}

inline void OGIPTable::setExact (const BoolArray& value)
{
  //## begin OGIPTable::setExact%3D6CF05502C9.set preserve=no
  m_exact = value;
  //## end OGIPTable::setExact%3D6CF05502C9.set
}

inline RealArray& OGIPTable::startWeight (const UniqueEnergy* uniqueEng)
{
  //## begin OGIPTable::startWeight%3D7CF9280320.qualget preserve=no
  return m_startWeight[uniqueEng];
  //## end OGIPTable::startWeight%3D7CF9280320.qualget
}

inline RealArray& OGIPTable::endWeight (const UniqueEnergy* uniqueEng)
{
  //## begin OGIPTable::endWeight%3D7CF9D001BF.qualget preserve=no
  return m_endWeight[uniqueEng];
  //## end OGIPTable::endWeight%3D7CF9D001BF.qualget
}

inline const IntegerArray& OGIPTable::recordNumbers () const
{
  //## begin OGIPTable::recordNumbers%3E42CB9201FB.get preserve=no
  return m_recordNumbers;
  //## end OGIPTable::recordNumbers%3E42CB9201FB.get
}

inline void OGIPTable::setRecordNumbers (const IntegerArray& value)
{
  //## begin OGIPTable::setRecordNumbers%3E42CB9201FB.set preserve=no
  m_recordNumbers = value;
  //## end OGIPTable::setRecordNumbers%3E42CB9201FB.set
}

inline const IntegerArray& OGIPTable::bracket () const
{
  //## begin OGIPTable::bracket%3E42CBD701AB.get preserve=no
  return m_bracket;
  //## end OGIPTable::bracket%3E42CBD701AB.get
}

inline void OGIPTable::setBracket (const IntegerArray& value)
{
  //## begin OGIPTable::setBracket%3E42CBD701AB.set preserve=no
  m_bracket = value;
  //## end OGIPTable::setBracket%3E42CBD701AB.set
}

inline const std::vector<ModParam*>& OGIPTable::addParam () const
{
  //## begin OGIPTable::addParam%44E33E680193.get preserve=no
  return m_addParam;
  //## end OGIPTable::addParam%44E33E680193.get
}

inline void OGIPTable::addParam (const std::vector<ModParam*>& value)
{
  //## begin OGIPTable::addParam%44E33E680193.set preserve=no
  m_addParam = value;
  //## end OGIPTable::addParam%44E33E680193.set
}

//## begin module%3D2EE1E60227.epilog preserve=yes
//## end module%3D2EE1E60227.epilog


#endif
